Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 1270)
+++ lemon/graph_to_eps.h	(revision 1249)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/hao_orlin.h
===================================================================
--- lemon/hao_orlin.h	(revision 1270)
+++ lemon/hao_orlin.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -54,6 +54,6 @@
   /// preflow push-relabel algorithm. Our implementation calculates
   /// the minimum cut in \f$ O(n^2\sqrt{m}) \f$ time (we use the
-  /// highest-label rule), or in \f$O(nm)\f$ for unit capacities. A notable
-  /// use of this algorithm is testing network reliability.
+  /// highest-label rule), or in \f$O(nm)\f$ for unit capacities. The
+  /// purpose of such algorithm is e.g. testing network reliability.
   ///
   /// For an undirected graph you can run just the first phase of the
@@ -913,6 +913,4 @@
     /// source-side (i.e. a set \f$ X\subsetneq V \f$ with
     /// \f$ source \in X \f$ and minimal outgoing capacity).
-    /// It updates the stored cut if (and only if) the newly found one
-    /// is better.
     ///
     /// \pre \ref init() must be called before using this function.
@@ -927,6 +925,4 @@
     /// sink-side (i.e. a set \f$ X\subsetneq V \f$ with
     /// \f$ source \notin X \f$ and minimal outgoing capacity).
-    /// It updates the stored cut if (and only if) the newly found one
-    /// is better.
     ///
     /// \pre \ref init() must be called before using this function.
@@ -938,6 +934,6 @@
     /// \brief Run the algorithm.
     ///
-    /// This function runs the algorithm. It chooses source node,
-    /// then calls \ref init(), \ref calculateOut()
+    /// This function runs the algorithm. It finds nodes \c source and
+    /// \c target arbitrarily and then calls \ref init(), \ref calculateOut()
     /// and \ref calculateIn().
     void run() {
@@ -949,7 +945,7 @@
     /// \brief Run the algorithm.
     ///
-    /// This function runs the algorithm. It calls \ref init(),
-    /// \ref calculateOut() and \ref calculateIn() with the given
-    /// source node.
+    /// This function runs the algorithm. It uses the given \c source node,
+    /// finds a proper \c target node and then calls the \ref init(),
+    /// \ref calculateOut() and \ref calculateIn().
     void run(const Node& s) {
       init(s);
@@ -970,7 +966,5 @@
     /// \brief Return the value of the minimum cut.
     ///
-    /// This function returns the value of the best cut found by the
-    /// previously called \ref run(), \ref calculateOut() or \ref
-    /// calculateIn().
+    /// This function returns the value of the minimum cut.
     ///
     /// \pre \ref run(), \ref calculateOut() or \ref calculateIn()
@@ -983,11 +977,7 @@
     /// \brief Return a minimum cut.
     ///
-    /// This function gives the best cut found by the
-    /// previously called \ref run(), \ref calculateOut() or \ref
-    /// calculateIn().
-    ///
-    /// It sets \c cutMap to the characteristic vector of the found
-    /// minimum value cut - a non-empty set \f$ X\subsetneq V \f$
-    /// of minimum outgoing capacity (i.e. \c cutMap will be \c true exactly
+    /// This function sets \c cutMap to the characteristic vector of a
+    /// minimum value cut: it will give a non-empty set \f$ X\subsetneq V \f$
+    /// with minimal outgoing capacity (i.e. \c cutMap will be \c true exactly
     /// for the nodes of \f$ X \f$).
     ///
Index: lemon/hartmann_orlin_mmc.h
===================================================================
--- lemon/hartmann_orlin_mmc.h	(revision 1270)
+++ lemon/hartmann_orlin_mmc.h	(revision 959)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -99,9 +99,8 @@
   /// This class implements the Hartmann-Orlin algorithm for finding
   /// a directed cycle of minimum mean cost in a digraph
-  /// \cite hartmann93finding, \cite dasdan98minmeancycle.
-  /// This method is based on \ref KarpMmc "Karp"'s original algorithm, but
-  /// applies an early termination scheme. It makes the algorithm
-  /// significantly faster for some problem instances, but slower for others.
-  /// The algorithm runs in time O(nm) and uses space O(n<sup>2</sup>+m).
+  /// \ref amo93networkflows, \ref dasdan98minmeancycle.
+  /// It is an improved version of \ref KarpMmc "Karp"'s original algorithm,
+  /// it applies an efficient early termination scheme.
+  /// It runs in time O(ne) and uses space O(n<sup>2</sup>+e).
   ///
   /// \tparam GR The type of the digraph the algorithm runs on.
@@ -144,12 +143,9 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref lemon::HartmannOrlinMmcDefaultTraits
-    /// "default traits class",
+    /// Using the \ref HartmannOrlinMmcDefaultTraits "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// \brief The
-    /// \ref lemon::HartmannOrlinMmcDefaultTraits "traits class"
-    /// of the algorithm
+    /// The \ref HartmannOrlinMmcDefaultTraits "traits class" of the algorithm
     typedef TR Traits;
 
@@ -279,6 +275,6 @@
     ///
     /// If you don't call this function before calling \ref run() or
-    /// \ref findCycleMean(), a local \ref Path "path" structure
-    /// will be allocated. The destuctor deallocates this automatically
+    /// \ref findCycleMean(), it will allocate a local \ref Path "path"
+    /// structure. The destuctor deallocates this automatically
     /// allocated object, of course.
     ///
Index: lemon/howard_mmc.h
===================================================================
--- lemon/howard_mmc.h	(revision 1271)
+++ lemon/howard_mmc.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -99,5 +99,5 @@
   /// This class implements Howard's policy iteration algorithm for finding
   /// a directed cycle of minimum mean cost in a digraph
-  /// \cite dasdan98minmeancycle, \cite dasdan04experimental.
+  /// \ref amo93networkflows, \ref dasdan98minmeancycle.
   /// This class provides the most efficient algorithm for the
   /// minimum mean cycle problem, though the best known theoretical
@@ -143,27 +143,10 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref lemon::HowardMmcDefaultTraits "default traits class",
+    /// Using the \ref HowardMmcDefaultTraits "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// The \ref lemon::HowardMmcDefaultTraits "traits class" of the algorithm
+    /// The \ref HowardMmcDefaultTraits "traits class" of the algorithm
     typedef TR Traits;
-
-    /// \brief Constants for the causes of search termination.
-    ///
-    /// Enum type containing constants for the different causes of search
-    /// termination. The \ref findCycleMean() function returns one of
-    /// these values.
-    enum TerminationCause {
-
-      /// No directed cycle can be found in the digraph.
-      NO_CYCLE = 0,
-
-      /// Optimal solution (minimum cycle mean) is found.
-      OPTIMAL = 1,
-
-      /// The iteration count limit is reached.
-      ITERATION_LIMIT
-    };
 
   private:
@@ -283,6 +266,6 @@
     ///
     /// If you don't call this function before calling \ref run() or
-    /// \ref findCycleMean(), a local \ref Path "path" structure
-    /// will be allocated. The destuctor deallocates this automatically
+    /// \ref findCycleMean(), it will allocate a local \ref Path "path"
+    /// structure. The destuctor deallocates this automatically
     /// allocated object, of course.
     ///
@@ -342,26 +325,11 @@
     }
 
-    /// \brief Find the minimum cycle mean (or an upper bound).
+    /// \brief Find the minimum cycle mean.
     ///
     /// This function finds the minimum mean cost of the directed
-    /// cycles in the digraph (or an upper bound for it).
-    ///
-    /// By default, the function finds the exact minimum cycle mean,
-    /// but an optional limit can also be specified for the number of
-    /// iterations performed during the search process.
-    /// The return value indicates if the optimal solution is found
-    /// or the iteration limit is reached. In the latter case, an
-    /// approximate solution is provided, which corresponds to a directed
-    /// cycle whose mean cost is relatively small, but not necessarily
-    /// minimal.
-    ///
-    /// \param limit  The maximum allowed number of iterations during
-    /// the search process. Its default value implies that the algorithm
-    /// runs until it finds the exact optimal solution.
-    ///
-    /// \return The termination cause of the search process.
-    /// For more information, see \ref TerminationCause.
-    TerminationCause findCycleMean(int limit =
-                                   std::numeric_limits<int>::max()) {
+    /// cycles in the digraph.
+    ///
+    /// \return \c true if a directed cycle exists in the digraph.
+    bool findCycleMean() {
       // Initialize and find strongly connected components
       init();
@@ -369,18 +337,11 @@
 
       // Find the minimum cycle mean in the components
-      int iter_count = 0;
-      bool iter_limit_reached = false;
       for (int comp = 0; comp < _comp_num; ++comp) {
         // Find the minimum mean cycle in the current component
         if (!buildPolicyGraph(comp)) continue;
         while (true) {
-          if (++iter_count > limit) {
-            iter_limit_reached = true;
-            break;
-          }
           findPolicyCycle();
           if (!computeNodeDistances()) break;
         }
-
         // Update the best cycle (global minimum mean cycle)
         if ( _curr_found && (!_best_found ||
@@ -391,13 +352,6 @@
           _best_node = _curr_node;
         }
-
-        if (iter_limit_reached) break;
-      }
-
-      if (iter_limit_reached) {
-        return ITERATION_LIMIT;
-      } else {
-        return _best_found ? OPTIMAL : NO_CYCLE;
-      }
+      }
+      return _best_found;
     }
 
Index: lemon/karp_mmc.h
===================================================================
--- lemon/karp_mmc.h	(revision 1270)
+++ lemon/karp_mmc.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -99,6 +99,6 @@
   /// This class implements Karp's algorithm for finding a directed
   /// cycle of minimum mean cost in a digraph
-  /// \cite karp78characterization, \cite dasdan98minmeancycle.
-  /// It runs in time O(nm) and uses space O(n<sup>2</sup>+m).
+  /// \ref amo93networkflows, \ref dasdan98minmeancycle.
+  /// It runs in time O(ne) and uses space O(n<sup>2</sup>+e).
   ///
   /// \tparam GR The type of the digraph the algorithm runs on.
@@ -141,9 +141,9 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref lemon::KarpMmcDefaultTraits "default traits class",
+    /// Using the \ref KarpMmcDefaultTraits "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// The \ref lemon::KarpMmcDefaultTraits "traits class" of the algorithm
+    /// The \ref KarpMmcDefaultTraits "traits class" of the algorithm
     typedef TR Traits;
 
@@ -271,6 +271,6 @@
     ///
     /// If you don't call this function before calling \ref run() or
-    /// \ref findCycleMean(), a local \ref Path "path" structure
-    /// will be allocated. The destuctor deallocates this automatically
+    /// \ref findCycleMean(), it will allocate a local \ref Path "path"
+    /// structure. The destuctor deallocates this automatically
     /// allocated object, of course.
     ///
Index: lemon/kruskal.h
===================================================================
--- lemon/kruskal.h	(revision 1270)
+++ lemon/kruskal.h	(revision 631)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -31,4 +31,7 @@
 ///\file
 ///\brief Kruskal's algorithm to compute a minimum cost spanning tree
+///
+///Kruskal's algorithm to compute a minimum cost spanning tree.
+///
 
 namespace lemon {
Index: lemon/lemon.pc.cmake
===================================================================
--- lemon/lemon.pc.cmake	(revision 1012)
+++ lemon/lemon.pc.cmake	(revision 1012)
@@ -0,0 +1,10 @@
+prefix=@CMAKE_INSTALL_PREFIX@
+exec_prefix=@CMAKE_INSTALL_PREFIX@/bin
+libdir=@CMAKE_INSTALL_PREFIX@/lib
+includedir=@CMAKE_INSTALL_PREFIX@/include
+
+Name: @PROJECT_NAME@
+Description: Library for Efficient Modeling and Optimization in Networks
+Version: @PROJECT_VERSION@
+Libs: -L${libdir} -lemon @GLPK_LIBS@ @CPLEX_LIBS@ @SOPLEX_LIBS@ @CLP_LIBS@ @CBC_LIBS@
+Cflags: -I${includedir}
Index: lemon/lemon.pc.in
===================================================================
--- lemon/lemon.pc.in	(revision 1133)
+++ lemon/lemon.pc.in	(revision 705)
@@ -1,10 +1,10 @@
-prefix=@CMAKE_INSTALL_PREFIX@
-exec_prefix=@CMAKE_INSTALL_PREFIX@/bin
-libdir=@CMAKE_INSTALL_PREFIX@/lib
-includedir=@CMAKE_INSTALL_PREFIX@/include
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
 
-Name: @PROJECT_NAME@
+Name: @PACKAGE_NAME@
 Description: Library for Efficient Modeling and Optimization in Networks
-Version: @PROJECT_VERSION@
+Version: @PACKAGE_VERSION@
 Libs: -L${libdir} -lemon @GLPK_LIBS@ @CPLEX_LIBS@ @SOPLEX_LIBS@ @CLP_LIBS@ @CBC_LIBS@
 Cflags: -I${includedir}
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 1270)
+++ lemon/lgf_reader.h	(revision 1107)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -155,14 +155,14 @@
     };
 
-    template <typename Value,
-              typename Map = std::map<std::string, Value> >
+    template <typename Value>
     struct MapLookUpConverter {
-      const Map& _map;
-
-      MapLookUpConverter(const Map& map)
+      const std::map<std::string, Value>& _map;
+
+      MapLookUpConverter(const std::map<std::string, Value>& map)
         : _map(map) {}
 
       Value operator()(const std::string& str) {
-        typename Map::const_iterator it = _map.find(str);
+        typename std::map<std::string, Value>::const_iterator it =
+          _map.find(str);
         if (it == _map.end()) {
           std::ostringstream msg;
@@ -171,37 +171,4 @@
         }
         return it->second;
-      }
-    };
-
-    template <typename Value,
-              typename Map1 = std::map<std::string, Value>,
-              typename Map2 = std::map<std::string, Value> >
-    struct DoubleMapLookUpConverter {
-      const Map1& _map1;
-      const Map2& _map2;
-
-      DoubleMapLookUpConverter(const Map1& map1, const Map2& map2)
-        : _map1(map1), _map2(map2) {}
-
-      Value operator()(const std::string& str) {
-        typename Map1::const_iterator it1 = _map1.find(str);
-        typename Map2::const_iterator it2 = _map2.find(str);
-        if (it1 == _map1.end()) {
-          if (it2 == _map2.end()) {
-            std::ostringstream msg;
-            msg << "Item not found: " << str;
-            throw FormatError(msg.str());
-          } else {
-            return it2->second;
-          }
-        } else {
-          if (it2 == _map2.end()) {
-            return it1->second;
-          } else {
-            std::ostringstream msg;
-            msg << "Item is ambigous: " << str;
-            throw FormatError(msg.str());
-          }
-        }
       }
     };
@@ -1231,8 +1198,7 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref lemon::DigraphReader "DigraphReader" class
-  ///
-  /// This function just returns a \ref lemon::DigraphReader
-  /// "DigraphReader" class.
+  /// \brief Return a \ref DigraphReader class
+  ///
+  /// This function just returns a \ref DigraphReader class.
   ///
   /// With this function a digraph can be read from an
@@ -1254,8 +1220,7 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the
-  /// \ref lemon::DigraphReader "DigraphReader"
+  /// For a complete documentation, please see the \ref DigraphReader
   /// class documentation.
-  /// \warning Don't forget to put the \ref lemon::DigraphReader::run() "run()"
+  /// \warning Don't forget to put the \ref DigraphReader::run() "run()"
   /// to the end of the parameter list.
   /// \relates DigraphReader
@@ -2111,7 +2076,7 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref lemon::GraphReader "GraphReader" class
-  ///
-  /// This function just returns a \ref lemon::GraphReader "GraphReader" class.
+  /// \brief Return a \ref GraphReader class
+  ///
+  /// This function just returns a \ref GraphReader class.
   ///
   /// With this function a graph can be read from an
@@ -2129,8 +2094,7 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the
-  /// \ref lemon::GraphReader "GraphReader"
+  /// For a complete documentation, please see the \ref GraphReader
   /// class documentation.
-  /// \warning Don't forget to put the \ref lemon::GraphReader::run() "run()"
+  /// \warning Don't forget to put the \ref GraphReader::run() "run()"
   /// to the end of the parameter list.
   /// \relates GraphReader
